Option Strict Off
Option Explicit On

Friend Class Form1
	Inherits System.Windows.Forms.Form
	'Set this to "1" if making an exe or "0" if debugging
	'(so that the full paths are included in the declare statements)
#Const EXE_BUILD = 1
	
#If EXE_BUILD Then
	Private Declare Function ECIO_GetDLLVersion Lib "ECIO_api.dll" () As Integer
    Private Declare Function ECIO_Open Lib "ECIO_api.dll" (ByVal index As Integer, ByRef pVID_PID As Byte) As Integer
	Private Declare Function ECIO_Close Lib "ECIO_api.dll" () As Integer
    Private Declare Function ECIO_Transmit Lib "ECIO_api.dll" (ByRef pDataOut As Byte, ByVal dwLenOut As Integer, ByRef pActualLenOut As Integer, ByRef pDataIn As Byte, ByVal dwExpectedLenIn As Integer, ByRef pActualLenIn As Integer, ByVal dwTimeout As Integer) As Integer
    Private Declare Function ECIO_GetDeviceCount Lib "ECIO_api.dll" (ByRef pVID_PID As Byte) As Integer
#Else
	Private Declare Function ECIO_GetDLLVersion Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
	Private Declare Function ECIO_Open Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByVal index As Long, ByRef pVID_PID As Any) As Long
	Private Declare Function ECIO_Close Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" () As Long
	Private Declare Function ECIO_Transmit Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pDataOut As Any, ByVal dwLenOut As Long, ByRef pActualLenOut As Long, ByRef pDataIn As Any, ByVal dwExpectedLenIn As Long, ByRef pActualLenIn As Long, ByVal dwTimeout As Long) As Long
	Private Declare Function ECIO_GetDeviceCount Lib "C:\DEV\Flowcode V3\Components\USB Pack\Current\DLL Interface\V4\VB_App\ECIO_api.dll" (ByRef pVID_PID As Any) As Long
#End If
	
	Private sID(20) As Byte

	
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		'Set the identifier
		sID(0) = Asc("v")
		sID(1) = Asc("i")
		sID(2) = Asc("d")
		sID(3) = Asc("_")
		sID(4) = Asc("1")
		sID(5) = Asc("2")
		sID(6) = Asc("b")
		sID(7) = Asc("f")
		sID(8) = Asc("&")
		sID(9) = Asc("p")
		sID(10) = Asc("i")
		sID(11) = Asc("d")
		sID(12) = Asc("_")
        sID(13) = Asc("f")
        sID(14) = Asc("0")
        sID(15) = Asc("3")
        sID(16) = Asc("1")
		sID(17) = 0
				
		Dim lRetVal As Integer
		lRetVal = ECIO_Open(0, sID(0))
		
	End Sub
	
	Private Sub Form1_FormClosing(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
		Dim Cancel As Boolean = eventArgs.Cancel
		Dim UnloadMode As System.Windows.Forms.CloseReason = eventArgs.CloseReason
		'Make sure the connection is closed
		ECIO_Close()
		eventArgs.Cancel = Cancel
	End Sub
	
    Private Sub Go_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Go.Click

        'Declare the transaction variables
        Dim Outgoing(0 To 2) As Byte
        Dim Incoming(0 To 2) As Byte
        Dim SentCnt As Long
        Dim ReceivedCnt As Long

        'Assign the Command to array index 0
        Outgoing(0) = Command.Text


        'If using command 2
        If Command.Text = 2 Then

            'Allow text characters by converting input to ascii representation
            Outgoing(1) = Asc(Data.Text)

        Else

            'Send the number directly
            Outgoing(1) = Data.Text

        End If


        'Perform send and receive transaction
        ECIO_Transmit(Outgoing(0), 2, SentCnt, Incoming(0), 1, ReceivedCnt, 10)


        'If using command 4
        If Command.Text = 4 Then

            If Incoming(0) < 255 Then

                'Convert the incoming number to an ascii character
                Retval.Text = Chr(Incoming(0))

            Else

                'Output the number directly
                Retval.Text = Incoming(0)

            End If

        Else

            'Output the number directly
            Retval.Text = Incoming(0)

        End If

    End Sub
End Class